;speak demo by semar - Sergio Marcello
;the following comes from the author of the DLL:
;================================================
; speak DLL by MetalMan (metallicas_world@hotmail.com)
; More information can be found at http://www.enkeladress.com/blitzspeaker.htm
; Make sure you unzipped the two files (speaker.dll, speaker.decls) to the Blitz
; userlib folder before you run this demo, else it won't compile.
; The userlib and demo can be distributed freely.
; Please send me a note if you like it or if you have any suggestions.
; More info can be found at: http://www.enkeladress.com/blitzspeaker.htm
;================================================

;consts
Const gadget_action = $401 ;gadget action event
Const keyboard = $101 ;key pressed event
Const btny = 110 ;y of buttons

;test if there's the speech synth available
If Not VoiceAvailable() Then
	Notify("Sorry, the speech synthesizer has not been detected on your system !",1)
	End
Else
	;voice initialization
	InitVoice()
EndIf

;create window and gadgets
Global window = CenterWindow("So To Speak V. 1 by Semar - DLL by MetalMan",360,240)
Global text_area = CreateTextArea(0,0,350,100,window)
;create buttons
Global button_pause=CreateButton( "PAUSE",5,btny,80,24,window )
Global button_stop =CreateButton( "STOP",95,btny,80,24,window )
Global button_say=CreateButton( "SAY",185,btny,80,24,window )
Global button_load=CreateButton( "Load a text file",270,btny,80,24,window )

;slider
Global vspeed = CreateSlider( 0,btny+40,ClientWidth(window)-16,16,window,1 ) 
SetSliderRange(vspeed,1,21)
SetSliderValue(vspeed,11)

;set initial voice speed
rate = -10 + SliderValue(vspeed)
SetVoiceRate(rate)
SetStatusText(window,"Voice Speed = " + rate)



;create text area and fill with some words
the_font = LoadFont ("arial",24,True)
SetTextAreaFont text_area,the_font
AddTextAreaText  text_area,"Type something here and press SAY"

;flag for end program
finito = False

;flush events..
While (WaitEvent() <> $803) And (Not finito)

;was it a gadget action event?
Select EventID()

	Case gadget_action
	
		;yes! let's see which gadget is involved
		Select EventSource()
		
		Case vspeed
			;set the voice speed
			set_voice_speed()
			
		;pressed button_load ?
		Case button_load
		
			;Yep!
			;txt file selection
			the_file$ = RequestFile$( "Pick a text file !","txt" )
			
			;if picked a valid file name
			If the_file <> "" Then
			
				;clear the text box
				SetGadgetText(text_area), " "
				
				;read the file
				fin = ReadFile (the_file)
				While Not Eof(fin)
					rec$ = ReadLine$ (fin)
					AddTextAreaText text_area,rec
					AddTextAreaText text_area,Chr(13)
				Wend	
			EndIf
		
		;pressed button_say ?	
		Case button_say
		
			;just clear some nasty char
			testo$ = replace_chars(TextAreaText$(text_area))
			
			;set the area text with the 'cleaned' text
			SetGadgetText(text_area),testo
			
			;if you have something to say, then say it..!     ;-)
			If testo <> "" Then
				Say (TextAreaText$(text_area))
			EndIf

		;pressed button_pause ?
		Case button_pause
			If Not paused Then
				;if speaking is in process
				If GetVoiceState() Then
					PauseVoice()
					paused = True
					SetGadgetText(button_pause),"RESUME"
				EndIf
			Else
				ResumeVoice()
				paused = False
				SetGadgetText(button_pause),"PAUSE"
			EndIf

		Case button_stop
			;stop
			InitVoice()
			
			;set the voice speed
			set_voice_speed()
			
			;eventually reset the pause/resume button caption and flag
			SetGadgetText(button_pause),"PAUSE"
			paused = False


		End Select		
		
		
		
	;was a keyboar event ?	
	Case keyboard
		If EventData() = 1 Then
			finito = True ;will end the program
		EndIf
		
	Default
		;Notify(EventID())
	
End Select

Wend

;free speech synth
FreeVoice()

;end program
End

;=========================================
; Convenience function to open a centered window on the desktop...
Function CenterWindow(title$,width,height,group=0,style=13)
;=========================================
	x=(ClientWidth(Desktop())-width)/2
	y=(ClientHeight(Desktop())-height)/2
	Return CreateWindow (title$,x,y,width,height,group,style)
End Function

;=========================================
Function replace_chars$(testo$)
;=========================================
;just clear the text from 'unuseful' chars

testo = Replace$(testo,"<"," ")
testo = Replace$(testo,">"," ")
testo = Replace$(testo,"(R)"," ")
testo = Replace$(testo,"/"," ")
testo = Replace$(testo,"*"," ")
Return testo

End Function

;=========================================
Function set_voice_speed()
;=========================================
;set the voice speed to the slider value
rate = -10 + SliderValue(vspeed)
SetVoiceRate(rate)
SetStatusText(window,"Voice Speed = " + rate)

End Function